Please note: This project is no longer active. The website is kept online for historic purposes only.
If you´re looking for a Linux driver for your Atheros WLAN device, you should continue here .

Ticket #889 (closed defect: fixed)

Opened 13 years ago

Last modified 12 years ago

sylogs show error: ath_xr_rate_setup: rate table too small (13 > 15)

Reported by: Przemyslaw Bruski Assigned to: mtaylor
Priority: minor Milestone: version 0.9.5
Component: madwifi: driver Version: trunk
Keywords: XR ExtendedRange Cc:
Patch is attached: 1 Pending:

Description

Hi,

it seems that there is a small error in if_ath.c - incorrect constant is being used as maxrates cap.

        if (rt->rateCount > XR_NUM_SUP_RATES) {
                DPRINTF(sc, ATH_DEBUG_ANY,
                        "%s: rate table too small (%u > %u)\n",
                        __func__, rt->rateCount, IEEE80211_RATE_MAXSIZE);
                maxrates = IEEE80211_RATE_MAXSIZE;
        } else

Since the number of returned rates far exceeds the XR_NUM_SUP_RATES, instead of sending a patch I think it's best if you decide how the solution should look like.

best regards,

Przemyslaw Bruski

Attachments

madwifi-0.9.3-fix-rate-table-check.diff (1.3 kB) - added by mtaylor on 05/22/07 00:05:11.
Patch for rate table too small when both XR and standard rates are retrieved from HAL into sc_xr_rates

Change History

09/18/06 05:33:11 changed by mrenzmann

  • status changed from new to assigned.
  • owner set to mrenzmann.

The quoted code is wrong. Both IEEE80211_RATE_MAXSIZE should be replaced with XR_NUM_SUP_RATES here. Either that, or the XR_NUM_SUP_RATES should be replaced with IEEE80211_RATE_MAXSIZE. Both options should be tried IMO.

05/22/07 00:05:11 changed by mtaylor

  • attachment madwifi-0.9.3-fix-rate-table-check.diff added.

Patch for rate table too small when both XR and standard rates are retrieved from HAL into sc_xr_rates

05/22/07 00:08:14 changed by mtaylor

I've studied the code and I believe that the correct patch is attached. I'd love to hear more info from others. When xr is enabled, iwlist athX rate still only seems to list the standard rates - but the warning is gone and the full set of rates are accessible in the rate table when iterating.

FYI: While this patch eliminates the warning and unnecessary clipping of the numrates sizing variable, it does not appear to affect iwlist output. iwlist seems to still report standard rates regardless of the value of xr.

- M

05/22/07 00:08:49 changed by mtaylor

Signed-off-by: Michael Taylor (mike.taylor@apprion.com)

05/22/07 00:09:20 changed by mtaylor

  • patch_attached set to 1.

05/22/07 00:36:17 changed by mentor

This patch is certainly consistent with the other code; might not be correct applied anyway.

r2362

05/22/07 06:32:12 changed by mrenzmann

  • milestone changed from version 0.9.x - progressive release candidate phase to version 0.9.4.

What about the following (see comment 2):

FYI: While this patch eliminates the warning and unnecessary clipping of the numrates sizing variable, it does not appear to affect iwlist output. iwlist seems to still report standard rates regardless of the value of xr.

(follow-up: ↓ 8 ) 05/22/07 23:00:35 changed by mtaylor

  • status changed from assigned to new.
  • owner changed from mrenzmann to mtaylor.

I was wrong:

ath0 12 available bit-rates :

1Mb/s 2Mb/s 5.5Mb/s 6Mb/s 9Mb/s 11Mb/s 12Mb/s 18Mb/s 24Mb/s 36Mb/s 48Mb/s 54Mb/s Current Bit Rate:1Mb/s

(in reply to: ↑ 7 ) 05/23/07 06:14:02 changed by mrenzmann

Replying to mtaylor:

I was wrong:

Looks like the patch is ready to be committed then. Any objections?

05/23/07 18:59:05 changed by mtaylor

  • status changed from new to closed.
  • resolution set to fixed.

The code is correct and behaving as expected. I'm closing the ticket.

02/11/08 06:12:11 changed by mrenzmann

  • milestone changed from version 0.9.4 to version 0.9.5.